unit UnitRasEnum;
//michel.bardou@wanadoo.fr
//http://perso.wanadoo.fr/bardou/michel/

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

const
  RAS_MaxEntryName      =  256;
  RAS_MaxDeviceName     =  128;
  RAS_MaxDeviceType     =  16;

type
  TForm1 = class(TForm)
    ButtonListerLesConnexions: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    ListBoxLesConnexions: TListBox;
    ButtonDeconnexion: TButton;
    Label3: TLabel;
    Label4: TLabel;
    ButtonToutDeconnecter: TButton;
    procedure ButtonListerLesConnexionsClick(Sender: TObject);
    procedure ButtonDeconnexionClick(Sender: TObject);
    procedure ButtonToutDeconnecterClick(Sender: TObject);
  private
    procedure EnumerationDesConnections;
  public
    { Dclarations publiques }
  end;

  HRASConn = DWORD;

  PRASConn = ^TRASConn;
  TRASConn = record
     dwSize: DWORD;
     rasConn: HRASConn;     // handle de la connexion
     szEntryName: Array[0..RAS_MaxEntryName] of Char;
     szDeviceType : Array[0..RAS_MaxDeviceType] of Char;
     szDeviceName : array [0..RAS_MaxDeviceName] of char;
  end;

  PRASConnStatus = ^TRASConnStatus;
  TRASConnStatus = record
    dwSize: LongInt;
    rasConnstate: Word;
    dwError: LongInt;
    szDeviceType: Array[0..RAS_MaxDeviceType] of Char;
    szDeviceName: Array[0..RAS_MaxDeviceName] of Char;
  end;


var
  Form1: TForm1;
// entte des fonctions que l'on souhaite utiliser et qui seront issu de la
// dll RASAPI32.dll
function RasEnumConnections(RASConn: PrasConn;           { buffer receant les donnes }
                            var BufSize: DWord;           { taille du buffer }
                            var Connections: DWord        { nombre de connexions }
                            ): LongInt; stdcall;
function RasHangUp(RASConn: hrasConn): LongInt; stdcall;      { handle de la connection  dconnecter }
function RasGetConnectStatus(RASConn: hrasConn;        { handle to Remote Access Connection of interest }
                             RASConnStatus: PRASConnStatus        { buffer to receive status data }
                             ): LongInt; stdcall;


implementation

{$R *.DFM}

const
  RAS_DLL = 'RASAPI32.dll';

var
  TabRasConn      :array[1..10]of TRASConn;
  //Mettre plus de 10 si vous risquez d'avoir plus de 10 connexions !
  NbConnections   : DWord;// servira  indiquer le nombre de connexions


// indispensable pour pouvoir utiliser les fonctions de la dll RASAPI32.dll :

function RasEnumConnections; external RAS_DLL name 'RasEnumConnectionsA';
function RasHangUp; external RAS_DLL name 'RasHangUpA';
function RasGetConnectStatus; external RAS_DLL name 'RasGetConnectStatusA';


procedure TForm1.EnumerationDesConnections;
// permet de lister les connexions en cours
var
  BufSize : DWord;
  i       :integer;
begin
    TabRasconn[1].dwSize := Sizeof(TRasconn);
    BufSize := Sizeof(TabRasconn);
    // RasEnumConnections permet de rcuprer dans le tableau TabRasConn les
    // caractristiques des connexions en cours
    if RasEnumConnections(@TabRasConn, BufSize, NbConnections)<>0 then ShowMessage('erreur RasEnumConnections');
    Label2.Caption:=IntToStr(NbConnections);// nombre de connexions en cours
    ListBoxLesConnexions.Items.Clear;
    if NbConnections>0 then
      for i:=1 to NbConnections do
      begin
        // pour chaque connexion, on affiche ses caractristiques
        ListBoxLesConnexions.Items.Add(string(TabRasconn[i].szEntryName)+' '
                  +string(TabRasconn[i].szDeviceType)+' '
                  +string(TabRasconn[i].szDeviceName));
      end;
end;

procedure TForm1.ButtonListerLesConnexionsClick(Sender: TObject);
begin
  EnumerationDesConnections;
end;



procedure FermeConnexion(HandleConnexion:HRASConn);
  // FermeConnexion appelle RasHangUp(handle d'une connextion).
  // Cet API RasHangUp permet de dconnecter une connexion
var
  ReponseFonction :DWord;
  RASConnStatus   :TRASConnStatus;
  ResultatRasHangUp :DWord;
begin
  if HandleConnexion<>0 then
  begin
    RASConnStatus.dwSize := Sizeof(TRASConnStatus);
    ResultatRasHangUp:= RasHangUp(HandleConnexion);
    if ResultatRasHangUp=0 then //si pas d'erreur
    // la boucle suivante permet de ne pas rendre la main tant que la dconnexion n'est pas termine
    // voir aide  ce sujet sur aide API RasHangUp
    repeat
      ReponseFonction := RasGetConnectStatus(HandleConnexion, @RASConnStatus);
      sleep(0);
    until ReponseFonction = ERROR_INVALID_HANDLE
    else showMessage('erreur RasHangUp');
  end;
end;

procedure TForm1.ButtonDeconnexionClick(Sender: TObject);
begin
  // FermeConnexion appelle RasHangUp(handle d'une connextion).
  // Cet API permet de dconnecter une connexion
  // le Handle de la connexion a t obtenue par RasEnumConnexion par l'intermdiaire du tableau
  // TabRasconn. Par exemple, le Handle de la premire connexion est TabRasconn[1].Rasconn;
  FermeConnexion(TabRasconn[ListBoxLesConnexions.ItemIndex+1].Rasconn);
                      //les indices des listBox partent de 0
                     // TabRasconn part de 1 d'o le +1
  ListBoxLesConnexions.Items.Clear;// histoire d'obliger l'utilisateur  remettre  jour la liste des connections
end;

procedure TForm1.ButtonToutDeconnecterClick(Sender: TObject);
// permet de dconnecter une par une toutes les connexions.
var
  BufSize         :DWord;
  i               :integer;
  RASConnStatus   :TRASConnStatus;
begin
    TabRasconn[1].dwSize := Sizeof(TRasconn);//le dwsize du premier membre du tableau doit tre mis  Sizeof(TRasconn)
    RASConnStatus.dwSize := Sizeof(TRASConnStatus);
    BufSize := Sizeof(TabRasconn);// taille du buffer
    // rcupration de tous les handles ( les TabRasconn[i].Rasconn) des connexions en cours :
    if RasEnumConnections(@TabRasConn, BufSize, NbConnections)<>0 then ShowMessage('erreur RasEnumConnections');
    if NbConnections>0 then
    begin
        for i:=1 to NbConnections do // pour chaque connexion
        begin
          FermeConnexion(TabRasconn[i].Rasconn);// dconnexion  l'aide du Handle de la connexion
        end; //fin for
    end;
end;

end.
